//  prop_auto.cpp
//
//	YV12 to YUY2 converter PropertyPages
//
//	Copyright (c) 2005  N099
//

#include <streams.h>     // DirectShow (includes windows.h)

#include "hwdeintuids.h"
#include "hwdeint.h"

#include "prop_auto.h"
#include "resource.h"

// -----------------------------------------

CUnknown * WINAPI CHWDeintProp_AUTO::CreateInstance(LPUNKNOWN punk, HRESULT *phr)
{
    CHWDeintProp_AUTO * pNewObject = new CHWDeintProp_AUTO(punk);
    if (pNewObject == NULL)
	{
        *phr = E_OUTOFMEMORY;
    }
    return pNewObject;
}


CHWDeintProp_AUTO::CHWDeintProp_AUTO(LPUNKNOWN pUnk) :
	CBasePropertyPage(NAME("HWDeintProp_AUTO"), pUnk, IDD_HWDeintProp_AUTO, IDD_HWDeintProp_AUTO)
	,m_pIHWDeint(0)
{

}
void CHWDeintProp_AUTO::SetDirty(void)
{
	m_bDirty = TRUE;
	if (m_pPageSite)
    {
		m_pPageSite->OnStatusChange(PROPPAGESTATUS_DIRTY);
    }
}

HRESULT CHWDeintProp_AUTO::OnConnect(IUnknown *pUnk)
{
	if (pUnk == NULL)
    {
        return E_POINTER;
    }
    ASSERT(m_pIHWDeint == NULL);

	HRESULT hr;
        // pUnk ŃtB^̃JX^ C^[tFCX₢킹B
    hr = pUnk->QueryInterface(IHWDeint,
             reinterpret_cast<void**>(&m_pIHWDeint));
    return hr;
}

HRESULT CHWDeintProp_AUTO::OnActivate(void)
{
    ASSERT(m_pIHWDeint != NULL);
	// func select
	HRESULT hr = m_pIHWDeint->GetFuncN(&m_Val.nFunc);
	if (SUCCEEDED(hr)) {
		SendDlgItemMessage(m_Dlg, IDC_P1+m_Val.nFunc, BM_SETCHECK, BST_CHECKED, 0);
	}
	// field diff threshold
	SendDlgItemMessage(m_Dlg, IDC_FA_TH_FIELD, TBM_SETRANGE, 0, (LPARAM)MAKELONG(TH_MIN, TH_MAX));
	hr = m_pIHWDeint->GetFieldTH(&m_Val.thField);
	if (SUCCEEDED(hr)) {
		SendDlgItemMessage(m_Dlg, IDC_FA_TH_FIELD, TBM_SETPOS, 1, m_Val.thField);
	}
	// frame diff threshold
	SendDlgItemMessage(m_Dlg, IDC_FA_TH_FRAME, TBM_SETRANGE, 0, (LPARAM)MAKELONG(TH_MIN, TH_MAX));
	hr = m_pIHWDeint->GetFrameTH(&m_Val.thFrame);
	if (SUCCEEDED(hr)) {
		SendDlgItemMessage(m_Dlg, IDC_FA_TH_FRAME, TBM_SETPOS, 1, m_Val.thFrame);
	}
	// display mode
	hr = m_pIHWDeint->GetDispMode(&m_Val.dispmode);
	if (SUCCEEDED(hr)) {
		SendDlgItemMessage(m_Dlg, IDC_FA_HIDE+m_Val.dispmode, BM_SETCHECK, BST_CHECKED, 0);
	}
	
	m_NewVal = m_Val;

	return S_OK;
}

BOOL CHWDeintProp_AUTO::OnReceiveMessage(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch ( uMsg )
	{
	case WM_COMMAND:
		if(LOWORD(wParam)>=IDC_P1 && LOWORD(wParam)<IDC_P1+FUNC_N){
			m_NewVal.nFunc = wParam - IDC_P1;
			SetDirty();
			return (LRESULT) 1;
		}
		
		if(LOWORD(wParam)>=IDC_FA_HIDE && LOWORD(wParam)<=IDC_FA_FIELD){
			m_NewVal.dispmode = wParam - IDC_FA_HIDE;
			SetDirty();
			return (LRESULT) 1;
		}

		if(LOWORD(wParam)==IDC_FA_RESET){
			m_NewVal.thField  = TH_FIELD_DEFAULT;
			m_NewVal.thFrame  = TH_FRAME_DEFAULT;
			m_pIHWDeint->SetFieldTH(m_NewVal.thField);
			m_pIHWDeint->SetFrameTH(m_NewVal.thFrame);
			SendDlgItemMessage(m_Dlg, IDC_FA_TH_FRAME, TBM_SETPOS, 1, m_NewVal.thFrame);
			SendDlgItemMessage(m_Dlg, IDC_FA_TH_FIELD, TBM_SETPOS, 1, m_NewVal.thField);
			SendDlgItemMessage(m_Dlg, IDC_FA_HIDE, BM_SETCHECK, BST_CHECKED, 0);
			CheckRadioButton(m_Dlg, IDC_FA_HIDE, IDC_FA_FIELD, IDC_FA_HIDE);
			m_NewVal.dispmode = DISP_HIDE;
			SetDirty();
			return (LRESULT) 1;
		}
		break;
	case WM_HSCROLL:
		// [U[XC_𓮂B
		switch(LOWORD(wParam))
		{
		case TB_BOTTOM:
		case TB_LINEDOWN:
		case TB_PAGEDOWN:
		case SB_THUMBTRACK:
		case TB_PAGEUP:
		case TB_LINEUP:
		case TB_TOP:
			m_NewVal.thField = SendDlgItemMessage(m_Dlg, IDC_FA_TH_FIELD, TBM_GETPOS, 0, 0);
			m_NewVal.thFrame = SendDlgItemMessage(m_Dlg, IDC_FA_TH_FRAME, TBM_GETPOS, 0, 0);
			m_pIHWDeint->SetFieldTH(m_NewVal.thField);
			m_pIHWDeint->SetFrameTH(m_NewVal.thFrame);
			SetDirty();
		}
		return (LRESULT) 1;
	}

	// eNXɃbZ[WB
    return CBasePropertyPage::OnReceiveMessage(hwnd,uMsg,wParam,lParam);
}

HRESULT CHWDeintProp_AUTO::OnApplyChanges(void)
{
	m_Val = m_NewVal;
	m_pIHWDeint->SetFuncN(m_Val.nFunc);
	m_pIHWDeint->SetDispMode(m_Val.dispmode);
	return S_OK;
}

HRESULT CHWDeintProp_AUTO::OnDisconnect(void)
{
    if (m_pIHWDeint)
    {
		m_pIHWDeint->SetFieldTH(m_Val.thField);
		m_pIHWDeint->SetFrameTH(m_Val.thFrame);
		
		m_pIHWDeint->Release();
		m_pIHWDeint = NULL;
	}
	return S_OK;
}


