//  util.cpp
//
//	reg utility functions
//
//	Copyright (c) 2005 N099
//
#include <windows.h>
#include <streams.h>

#include <vector>
#include <algorithm>
#include <tchar.h>
#include <atlbase.h>

#include "util.h"

using namespace std;


void LoadRegistryInfo(CONFIG *conf)
{
	HKEY hKey;
	DWORD val;
	DWORD size = sizeof(DWORD);
	LONG ret;
	RegOpenKeyEx(HWDI_REG_KEY, HWDI_REG_SUBKEY, 0, KEY_READ, &hKey);
 

	//video info2
	ret = RegQueryValueEx(hKey, "VIF2_interlace", NULL, NULL, (LPBYTE)&val, &size);
	conf->vif2.interlace = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "VIF2_tff", NULL, NULL, (LPBYTE)&val, &size);
	conf->vif2.vif_tff = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "VIF2_disp_mode", NULL, NULL, (LPBYTE)&val, &size);
	conf->vif2.disp_mode = (ret != ERROR_SUCCESS) ? 0 : val;

	//am media type2
	ret = RegQueryValueEx(hKey, "AM2_use_imedia2", NULL, NULL, (LPBYTE)&val, &size);
	conf->am2.use_imedia2 = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "AM2_tff", NULL, NULL, (LPBYTE)&val, &size);
	conf->am2.am2_tff = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "AM2_weave", NULL, NULL, (LPBYTE)&val, &size);
	conf->am2.weave = (ret != ERROR_SUCCESS) ? 0 : val;
	
	//aspect ratio
	ret = RegQueryValueEx(hKey, "AR_mode", NULL, NULL, (LPBYTE)&val, &size);
	conf->ar.ar_mode = (ret != ERROR_SUCCESS) ? AR_ORIG	: val;

	ret = RegQueryValueEx(hKey, "AR_h", NULL, NULL, (LPBYTE)&val, &size);
	conf->ar.ar_h = (ret != ERROR_SUCCESS) ? AR_H_DEF : val;

	ret = RegQueryValueEx(hKey, "AR_v", NULL, NULL, (LPBYTE)&val, &size);
	conf->ar.ar_v = (ret != ERROR_SUCCESS) ? AR_V_DEF : val;

	//misc
	ret = RegQueryValueEx(hKey, "ShowTrayIcon", NULL, NULL, (LPBYTE)&val, &size);
	conf->misc.tray = (ret != ERROR_SUCCESS) ? 1 : val;

	ret = RegQueryValueEx(hKey, "cnv_upstream", NULL, NULL, (LPBYTE)&val, &size);
	conf->misc.conv_upstream = (ret != ERROR_SUCCESS) ? 1 : val;

	ret = RegQueryValueEx(hKey, "not_connect_i", NULL, NULL, (LPBYTE)&val, &size);
	conf->misc.not_connect_iflg = (ret != ERROR_SUCCESS) ? 1 : val;

	//color
	ret = RegQueryValueEx(hKey, "colorspace", NULL, NULL, (LPBYTE)&val, &size);
	conf->colorspace = (ret != ERROR_SUCCESS) ? TYPE_ALL : val;

	//auto detection
	ret = RegQueryValueEx(hKey, "AD_field", NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.field = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "AD_flip", NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.field_flip = (ret != ERROR_SUCCESS) ? 0 : val;

	ret = RegQueryValueEx(hKey, "AD_field_diff", NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.field_diff = (ret != ERROR_SUCCESS) ? AD_DEF_FDIFF : val;

	ret = RegQueryValueEx(hKey, "AD_duration", NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.duration = (ret != ERROR_SUCCESS) ? AD_DEF_DURATION : val;

	ret = RegQueryValueEx(hKey, "AD_e_term", NULL, NULL, (LPBYTE)&val, &size);
	conf->ad.e_term = (ret != ERROR_SUCCESS) ? AD_DEF_ETERM : val;

	RegCloseKey(hKey);
}

void SaveRegistryInfo(CONFIG &conf)
{
	HKEY hKey;
	DWORD dispo, val;

	if (RegCreateKeyEx(
			HWDI_REG_KEY,
			HWDI_REG_SUBKEY,
			0,
			HWDI_REG_CLASS,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE,
			0, 
			&hKey, 
			&dispo) != ERROR_SUCCESS)
	{
		OutputDebugString(NAME("SaveRegistryInfo:Couldn't create HWDI_REG_SUBKEY"));
		return;
	}

	// check value & save
	val = conf.vif2.interlace;
	RegSetValueEx(hKey, "VIF2_interlace", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.vif2.vif_tff;
	RegSetValueEx(hKey, "VIF2_tff", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.vif2.disp_mode;
	RegSetValueEx(hKey, "VIF2_disp_mode", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.am2.use_imedia2;
	RegSetValueEx(hKey, "AM2_use_imedia2", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.am2.am2_tff;
	RegSetValueEx(hKey, "AM2_tff", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.am2.weave;
	RegSetValueEx(hKey, "AM2_weave", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	//aspect ratio
	val = conf.ar.ar_mode;
	RegSetValueEx(hKey, "AR_mode", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.ar.ar_h;
	RegSetValueEx(hKey, "AR_h", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.ar.ar_v;
	RegSetValueEx(hKey, "AR_v", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	//misc
	val = conf.misc.tray;
	RegSetValueEx(hKey, "ShowTrayIcon", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.misc.conv_upstream;
	RegSetValueEx(hKey, "cnv_upstream", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.misc.not_connect_iflg;
	RegSetValueEx(hKey, "not_connect_i", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	//auto detection
	val = conf.ad.field;
	RegSetValueEx(hKey, "AD_field", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.ad.field_flip;
	RegSetValueEx(hKey, "AD_flip", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.ad.field_diff;
	RegSetValueEx(hKey, "AD_field_diff", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.ad.duration;
	RegSetValueEx(hKey, "AD_duration", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	val = conf.ad.e_term;
	RegSetValueEx(hKey, "AD_e_term", 0, REG_DWORD, (LPBYTE)&val, sizeof(DWORD));

	RegCloseKey(hKey);
}

void LoadDSFlist(vector<dsfid> &list)
{
	HKEY  hKey;
	DWORD size;
	DWORD type;
	LONG  ret = ERROR_SUCCESS;
	LONG  ret2 = ERROR_SUCCESS;
	TCHAR s[16];
	BYTE *buf;

	RegOpenKeyEx(HWDI_REG_KEY, HWDI_REG_SUBKEY_DSF, 0, KEY_READ, &hKey);

	list.clear();

	for(int i=0; ret==ERROR_SUCCESS || ret2==ERROR_SUCCESS; ++i){
		dsfid di;
		//load CLSID
		_stprintf(s, "CLSID%.3d", i);
		ret = RegQueryValueEx(hKey, s, NULL, &type, NULL, &size);
		if(ret == ERROR_SUCCESS && type == REG_SZ){
			buf = new(nothrow) BYTE[size];
			if(!buf) break;
			ret = RegQueryValueEx(hKey, s, NULL, NULL, (LPBYTE)buf, &size);
			if(ret == ERROR_SUCCESS){
				if(_tcslen((LPCTSTR)buf)>0){
					CT2CW c((LPCTSTR)buf);
					di.setCLSID(c);
				}
			}
			delete[] buf;
		}
		//load NAME
		_stprintf(s, "NAME%.3d", i);
		ret2 = RegQueryValueEx(hKey, s, NULL, &type, NULL, &size);
		if(ret2 == ERROR_SUCCESS && type == REG_SZ){
			buf = new(nothrow) BYTE[size];
			if(!buf) break;
			ret2 = RegQueryValueEx(hKey, s, NULL, NULL, (LPBYTE)buf, &size);
			if(ret2 == ERROR_SUCCESS){
				if(_tcslen((LPCTSTR)buf)>0){
					CT2CW c((LPCTSTR)buf);
					di.setNAME(c);
				}
			}
			delete[] buf;
		}
		if(di.hasCLSID() || di.hasNAME()){
			list.push_back(di);
		}
	}
	sort(list.begin(), list.end());
	vector<dsfid>::iterator p = unique(list.begin(), list.end());
	list.erase(p, list.end());
	

	DbgLog((LOG_TRACE, 3, TEXT("LoadDSFlist:Loaded %d DSFs"), i-1));

	RegCloseKey(hKey);
}

void SaveDSFlist(vector<dsfid> &list)
{
	HKEY hKey;
	DWORD dispo;
	TCHAR s[16];
	TCHAR s_null[] = TEXT("");
	DWORD sz_s;
	BYTE buf[MAX_FILTER_NAME*sizeof(TCHAR)];
	LONG  ret = ERROR_SUCCESS;
	int i = 0;

	ASSERT(MAX_FILTER_NAME > CHARS_IN_GUID+1);

	if (RegCreateKeyEx(
			HWDI_REG_KEY,
			HWDI_REG_SUBKEY_DSF,
			0,
			HWDI_REG_CLASS,
			REG_OPTION_NON_VOLATILE,
			KEY_WRITE | KEY_READ,
			0, 
			&hKey, 
			&dispo) != ERROR_SUCCESS)
	{
		OutputDebugString(NAME("SaveDSFlist:Couldn't create HWDI_REG_SUBKEY_DSF"));
		return;
	}

	// clear all entries
	while(ret==ERROR_SUCCESS){
		sz_s = 16;
		ret = RegEnumValue(hKey, 0, s, &sz_s, NULL, NULL, NULL, NULL);
		if(ret == ERROR_SUCCESS){
			ret = RegDeleteValue(hKey, s);
		}
	}

	// save list
	vector<dsfid>::iterator p = list.begin();
	while(p != list.end()){
		//save name
		_stprintf(s, "NAME%.3d", i);
		if(p->hasNAME()){
			CW2CT c(p->c_str_name());
			_tcsncpy((TCHAR *)buf, c, MAX_FILTER_NAME);
		}else{
			_tcsncpy((TCHAR *)buf, s_null, MAX_FILTER_NAME);
		}
		RegSetValueEx(hKey, s, 0, REG_SZ, (const BYTE*)buf, _tcslen((LPCTSTR)buf)+1);
		//save CLSID
		_stprintf(s, "CLSID%.3d", i);
		if(p->hasCLSID()){
			CW2CT c(p->c_str_cls());
			_tcsncpy((TCHAR *)buf, c, MAX_FILTER_NAME);
		}else{
			_tcsncpy((TCHAR *)buf, s_null, MAX_FILTER_NAME);
		}
		RegSetValueEx(hKey, s, 0, REG_SZ, (const BYTE*)buf, _tcslen((LPCTSTR)buf)+1);
		++i;
		++p;
		if(i>100) break; //max 100 for safe
	}

	DbgLog((LOG_TRACE, 3, NAME("SaveDSFlist:Saved %d DSFs"), i));

	RegCloseKey(hKey);
}

